<template>
  <el-container>
    <el-header>CoupleEditor</el-header>
    <el-main>
      <div>
        <el-form
          ref="form"
          :model="item"
          label-width="120px"
        >
          <el-form-item label="Id">
            <el-input
              v-model="item.id"
              :disabled="true"
            />
          </el-form-item>
          <el-form-item label="이름">
            <el-input
              v-model="item.name"
            />
          </el-form-item>
          <el-form-item label="ssmate">
            <el-select
              v-model="item.ssmate.mod"
              placeholder="ssmate 선택해 주세요"
              @change="ssChg"
            >
              <el-option
                v-for="mate in mates.ss"
                :key="mate.id"
                :label="mate.mod"
                :value="mate.mod"
              />
            </el-select>
            <element
              v-if="isSsEdit"
              style="color: red;"
            >
              Json데이터 변경 사항이 있습니다 반영 완료해 주세요.
            </element>
            <el-button
              style="margin-left:10px;margin-bottom:10px;float: right;"
              type="primary"
              icon="el-icon-check"
              @click="jsonCheck('ss')"
            >
              Json 반영
            </el-button>
            <jsonEditor
              style="margin-top:5px"
              ref="ssEditor"
              type="ss"
              :on-change="onChange"
              :on-change-state="onChangeState"
              :json="item.ssmate.opt"
              :options="ssOptions"
            />
          </el-form-item>
          <el-form-item label="dsmate">
            <el-select
              v-model="item.dsmate.mod"
              placeholder="dsmate 선택해 주세요"
              @change="dsChg"
            >
              <el-option
                v-for="mate in mates.ds"
                :key="mate.id"
                :label="mate.mod"
                :value="mate.mod"
              />
            </el-select>
            <element
              v-if="isDsEdit"
              style="color: red;"
            >
              Json데이터 변경 사항이 있습니다 반영 완료해 주세요.
            </element>
            <el-button
              style="margin-left:10px;margin-bottom:10px;float: right;"
              type="primary"
              icon="el-icon-check"
              @click="jsonCheck('ds')"
            >
              Json 반영
            </el-button>
            <jsonEditor
              style="margin-top:5px"
              ref="dsEditor"
              type="ds"
              :on-change="onChange"
              :on-change-state="onChangeState"
              :json="item.dsmate.opt"
              :options="dsOptions"
            />
          </el-form-item>
        </el-form>
      </div>
    </el-main>
  </el-container>
</template>

<script>
import jsonEditor from '@/components/JsonEditor'
export default {
  components: {
    jsonEditor
  },
  props: {
    item: {
      required: true,
      type: Object,
      default: () => {
        return {}
      }
    }
  },
  data: function () {
    return {
      isSsEdit: false,
      isDsEdit: false,
      jsonCheckType: '',
      mates: [],
      ssOptions: {
        mode: 'code',
        onError: function (err) {
          alert(err.toString())
        }
        /* onChange: function () {
          try {
            console.log(JSON.stringify(this.$refs.jsoneditor.editor.get()))
          } catch (err) {
            console.error(err)
          }
        }.bind(this) */
      },
      dsOptions: {
        mode: 'code',
        onError: function (err) {
          alert(err.toString())
        }
        /* onChange: function () {
          try {
            console.log(JSON.stringify(this.$refs.jsoneditor.editor.get()))
          } catch (err) {
            console.error(err)
          }
        }.bind(this) */
      }
    }
  },
  mounted () {
    this.getMates()
  },
  methods: {
    jsonCheck (type) {
      this.jsonCheckType = type
      if (type === 'ss') {
        this.$refs.ssEditor.editorJsonGet()
      } else {
        this.$refs.dsEditor.editorJsonGet()
      }
    },
    onChangeState (isEdit, type) {
      if (type === 'ss') {
        this.isSsEdit = isEdit
      } else {
        this.isDsEdit = isEdit
      }
    },
    onChange (isSuccess, newJson) {
      // console.log(newJson)
      this.$message({
        type: 'success',
        message: 'Json 데이터 정상 반영'
      })
      if (isSuccess) {
        if (this.jsonCheckType === 'ss') {
          this.isSsEdit = false
          this.item.ssmate.opt = newJson
        } else {
          this.isDsEdit = false
          this.item.dsmate.opt = newJson
        }
      } else {
        this.$message({
          type: 'error',
          message: 'Json 데이터를 확인해 주세요'
        })
      }
    },
    ssChg () {
      for (const mate of this.mates.ss) {
        if (mate.mod === this.item.ssmate.mod) {
          this.item.ssmate.class = mate.class
          this.item.ssmate.mod = mate.mod
          this.item.ssmate.opt = mate.opt
          break
        }
      }
    },
    dsChg () {
      for (const mate of this.mates.ds) {
        if (mate.mod === this.item.dsmate.mod) {
          this.item.dsmate.class = mate.class
          this.item.dsmate.mod = mate.mod
          this.item.dsmate.opt = mate.opt
          break
        }
      }
      // console.log(this.item.dsmate.mod)
    },
    async getMates () {
      try {
        const { data } = await this.axios.get('mate')
        this.mates = data
        // console.log(data)
      } catch (error) {
        console.log(error)
      }
    }
  }
}
</script>

<style>

</style>
